# WebSocket Documentation

#### Overview

Defx offers websockets for consuming streaming market and user data streams. While the market streams websocket is open, consuming the user data streams would require you to authenticate.&#x20;

All our WebSockets expect a keep-alive ping-pong frame. Usually you dont have to do anything since all modern WebSocket libraries do this automatically.&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.defx.com/docs/api-docs/developer-hub/websocket-documentation.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
